//  .    7142  R/W   0,     7142      1
//        16  ,    6  ,    R/W
//    -  
//-   		0b 111000	00 0000 0000  (57344)
//-   		0b 111001	00 0000 0000  (58368)
//  					0b 000000	11 1111 1111      (1024 .)



/************************    7142   ******************************/
void write_to_AD7142_spi(unsigned int address, unsigned int data) //1       SS PB4 !!!!!!!!!!!!!!!!!!!!!!!!!
{

unsigned char MSB_stw;		//    
unsigned char LSB_stw;		//    
unsigned char MSB_data;		//     
unsigned char LSB_data;		//     
unsigned int start_word;		// -   -   
#asm ("cli");
start_word = 57344|(address & 1023);		//    .  address & 1023     
// 16   "start_word"    8- 
LSB_stw=(unsigned char) start_word;		//   ,      
MSB_stw=(unsigned char)(start_word>>8);	//  8 ,     

CS_act;		// SPI

// 16   "data"    8- 
LSB_data=(unsigned char) data;			//   ,      
MSB_data=(unsigned char)(data>>8);		//  8 ,  
//     spi  AD7142,   ,  .
//  32 
spi(MSB_stw);
spi(LSB_stw);
spi(MSB_data);
spi(LSB_data);
CS_unact;		// SPI

#asm("sei");
}//1
/************************************************************************************/

/************************    7142*******************************/      //      SS PB4 !!!!!!!!!!!!!!!!!!!!!!!!!
unsigned int  read_from_AD7142_spi (unsigned int address) {  //A

unsigned char MSB_stw;		//    
unsigned char LSB_stw;		//    
unsigned int data;			//    
unsigned int start_word;		// -   -   
#asm ("cli");
start_word = 58368|(address & 1023);		//       address & 1023     

// 16   "start_word"    8- 
LSB_stw=(unsigned char) start_word;		//   ,      
MSB_stw=(unsigned char)(start_word>>8);	//  8 ,     
CS_act;		// SPI
//  ,  7142      ,    
spi(MSB_stw);		//  ,   
spi(LSB_stw);		//  ,   
//       "address"  , 7142       
data = spi(0);		//  MSB ( )
data = data<<8;		//       
data|= spi(0);		//    (LSB)         ( 0  0  0)
CS_unact;		// SPI

return data;		//    
#asm("sei");
} //A

/************************************************************************************/


/************************    7142     ******************************/
//start_address -   ,     
//mass[] -  ,     
//counter - ,      (  N-1,    q=1,      -  ...
//   8,      8,     8   16 
// ,        

void write_to_AD7142_spi_serial(unsigned int start_address,  eeprom unsigned int  mass[],unsigned char num_mass,  unsigned char counter) {//1       SS PB4 !!!!!!!!!!!!!!!!!!!!!!!!!

unsigned char q;			//    
unsigned int eeprom *sel;		//    -    
unsigned char MSB_stw;		//    
unsigned char LSB_stw;		//    
unsigned char MSB_data;		//     
unsigned char LSB_data;		//     
unsigned int data;			//16    
unsigned int start_word;		// -   -   
#asm ("cli");
start_word = 57344|(start_address & 1023);		//       address & 1023     
sel = mass;						//      

// 16   "start_word"    8- 
LSB_stw=(unsigned char) start_word;            //   ,      
MSB_stw=(unsigned char)(start_word>>8);   //  8 ,     
CS_act;		// SPI
spi(MSB_stw);
spi(LSB_stw);

//      :
sel = &mass[num_mass];					//      
for (q=1; q<=counter; q++) {		//A               , q=2 -          ,      
data=*sel;						//       ,      sel

			// 16   "data"    8- 
LSB_data=(unsigned char) data;		//   ,      
MSB_data=(unsigned char)(data>>8);	//  8 ,  
spi(MSB_data);					//  spi
spi(LSB_data);
sel++;						//   .  

}//A
CS_unact;		// SPI
#asm("sei");
}//1
/************************************************************************************/